#include "ServiceConfig.h"

#include <stdlib.h>

#include "Logger.h"


// static 변수 초기화
CServiceConfig * CServiceConfig::m_pInstance = NULL;


#define DEFAULT_WORKER_PROCESS_COUNT     3     // default worker 프로세스 count


// 생성자
CServiceConfig::CServiceConfig()
{
	// default 값 설정.
	// 지정된 conf 파일에 해당 설정이 없어도 동작되도록 처리할 값에 대해서만 default 값을 정의한다.	
	m_nWorkerCount = DEFAULT_WORKER_PROCESS_COUNT;
	
}

// 소멸자 
CServiceConfig::~CServiceConfig()
{
	// 객체 소멸시... 
	// 만약 static GetInstance() 함수가 가르키는 객체가 자기 자신이라면...
	// 소멸 처리에 의해 문제가 발생할 수 있으므로... 이에 대한 처리를 해 준다.
	if( CServiceConfig::GetInstance() == this )
	{
		CServiceConfig::m_pInstance = NULL;
	}

}

bool CServiceConfig::Init( const std::string strProgramName, const std::string & strConfFileName, std::string & strErrorMessage )
{
	// 1. 임시 처리용 Instance 를 생성한다.
	CServiceConfig * pTempInstance = new CServiceConfig();

	// 2. 전달 받은 Config 정보를 임시 Instance 로 로딩한다.
	//   - 만약 로딩이 실패할 경우... 임시 Instance 객체를 삭제 처리한다.
	if( pTempInstance->Load( strProgramName, strConfFileName, strErrorMessage ) == false )
	{
		delete pTempInstance;
		pTempInstance = NULL;

		return false;	// 생성 실패 사유는 Error String 관련 함수를 사용하여 확인.
	}

	// 3. 전달받은 Conf 정보 로딩에 성공한 경우...
	//   - 기존 Instance 객체가 존재하는 경우.. 교체 처리..
	//   - 기존 Instance 객체가 없는 경우는 신규 Instance 사용토록 처리.
	if( CServiceConfig::GetInstance() == NULL )
	{
		CServiceConfig::m_pInstance = pTempInstance;
	}
	else
	{
		// Instance replace...
		CServiceConfig * pPreviosInstance = CServiceConfig::m_pInstance;
		CServiceConfig::m_pInstance = pTempInstance;
		
		delete pPreviosInstance;
	}

	return true;
}


CServiceConfig * CServiceConfig::GetInstance( ) 
{ 
	return CServiceConfig::m_pInstance; 
}


// 각 항목별 제약값은 기존 service_sync 모듈 소스를 참고하여 정의함.
bool CServiceConfig::Load( const std::string & strProgramName, const std::string & strConfFileName, std::string & strErrorMessage )
{
	// 변수 유효성 확인
	if( strProgramName.size() <= 0 )
	{
		strErrorMessage = "Config Program Name[" + strProgramName + "] not valid.";
		return false;
	}

	// Config class (lib 하위) 를 이용하여 config 파일 상의 정보를 로딩 처리 
	Config conf;

	if( conf.Open( strConfFileName ) == false )
	{
		strErrorMessage = "Config file[" + strConfFileName + "] open failed.";
		return false;
	}

	// Config 모듈에 로딩된 정보 중 필요한 정보만 가져온다...
	// - 만약 오류가 발생할 경우... 해당 내역은 Error String 에 저장 처리...

	std::string strValue;
	int nValue;
	std::vector< std::string > vecValue;

	
	// Log path
	if( GetConfigValue( conf, strProgramName, "DEFAULT_LOG_DIR", strValue, strErrorMessage ) == false )
		return false;
	else
	{
		m_strLogPath = strValue;
		strValue.clear();
	}

	// Log Level
	if( GetConfigValue( conf, strProgramName, "LOG_LEVEL", strValue, strErrorMessage ) == false )
		return false;
	else
	{
		nValue = atoi(strValue.c_str());		
		if( nValue < 0 || nValue > MAX_LOG_LEVEL )
		{
			strErrorMessage = "Config [LOG_LEVEL] value[" + strValue + "] is not valid";
			return false;
		}
		else
			m_nLogLevel = nValue;
		
		strValue.clear();
	}

	
	// TCP Listen port
	if( GetConfigValue( conf, strProgramName, "TCP_LISTEN_PORT", strValue, strErrorMessage ) == false )
		return false;
	else
	{
		nValue = atoi( strValue.c_str() );
		if( nValue <= 0 || nValue > 65535 )
		{
			strErrorMessage = "Config [TCP_LISTEN_PORT] value[" + strValue + "] is not valid";
			return false;
		}
		else
			m_nTcpListenPort = nValue;

		strValue.clear();
	}
	
	// Save path
	if( GetConfigValue( conf, strProgramName, "SAVE_ROOT_PATH", strValue, strErrorMessage ) == false )
		return false;
	else
	{
		m_strSaveRootPath = strValue;
		strValue.clear();
	}

	// WORKER_PROCESS_COUNT
	// - 정의 되지 않은 경우.. default 값 사용.
	// - 잘못 정의된 경우... 오류 처리
	if( GetConfigValue( conf, strProgramName, "WORKER_PROCESS_COUNT", strValue, strErrorMessage ) == true )
	{
		nValue = atoi( strValue.c_str() );
		if( nValue <= 0 || nValue > 100 )
		{
			strErrorMessage = "Config [WORKER_PROCESS_COUNT] value[" + strValue + "] is not valid.";
			return false;			
		}
		else
			m_nWorkerCount = nValue;

		strValue.clear();
	}
	
	
	// conf 정보 로딩이 모두 정상적으로 완료된 경우... 
	// 마지막으로 전달받은 config 명, section 정보를 저장한다.
	m_strConfigFileName = strConfFileName;
	m_strProgramName    = strProgramName;
	
	return true;
}


bool CServiceConfig::GetConfigValue( Config & conf, const std::string & strProgramName, const std::string strKey, std::string & strValue, std::string & strErrorMessage )
{
	// conf get value
	if( conf.GetConfig( strProgramName, strKey, strValue) == false )
	{
		if( conf.GetConfig( "COMMON", strKey, strValue) == false )
		{
			strErrorMessage = "Config [" + strKey + "] value is not exist";

			return false;
		}
	}

	// value check.
	if( strValue.empty() == true )
	{
		strErrorMessage = "Config [" + strKey + "] value is not valid";
		return false;
	}
	
	return true;
}

